/*
 * SaviCommonDialog.java
 *
 * Created on 23. srpen 2006, 13:00
 *
 */

package savi.dialogs;

import java.awt.*;
import java.awt.event.*;

/**
 * Class for making common dialogs.
 * @author Premysl JIRIK
 */
public class SaviCommonDialog  extends SaviDialogSkeleton implements ActionListener {
    boolean okPressed = false;
    Button ok, can;
    Panel pan = null;
    /**
     * content of dialog
     */
    public Panel content = null;
    
    /**
     * Creates a new instance of SaviCommonDialog, initialize caption.
     * @param caption form caption
     */
    public SaviCommonDialog(String caption) {
        super(caption);

        setLayout(new BorderLayout());
        content = new Panel();

        pan = new Panel();
        pan.add(new Container());
        pan.add(new Container());
        pan.add(ok = new Button("OK"));
        ok.addActionListener(this); 
        pan.add(can = new Button("Cancel"));
        can.addActionListener(this);
        
        add(content, BorderLayout.NORTH);
        add(pan, BorderLayout.SOUTH);
    }

    /**
     * Return <CODE>true</CODE> if user properly closed dialog (press OK).
     * @return <CODE>true</CODE> if user properly closed dialog
     */
    public boolean isOK() {
        return okPressed;
    }

    /**
     * Actions if user press "close".
     */
    protected void closePressed() {
        okPressed = false;
        super.closeCalled();
    }
    
    /**
     * Show dialog to user.
     * @return <CODE>true</CODE> if user closed dialog properly
     */
    public boolean showForm() {
        distributeKeyListeners();
        validate();
        pack();
        Dimension d = getToolkit().getScreenSize();
        setLocation((d.width - getWidth())/2, (d.height - getHeight())/2);

        setVisible(true);
        return okPressed;
    }
    
    /**
     * Handles the actionPerformed event - "close" or "ok".
     * @param ae the action event
     */
    public void actionPerformed(ActionEvent ae) {
        if(ae.getSource() == ok) {
            okPressed = true;
            setVisible(false);
        } else 
            if(ae.getSource() == can) {
                okPressed = false;
                setVisible(false);
            }
    }    
}
