/*
 * SaviDialogSkeleton.java
 *
 * Created on 5. jen 2006, 12:30
 *
 */

package savi.dialogs;

import java.awt.*;
import java.awt.event.*;

/**
 * Skeleton for making dialogs.
 * @author Premysl JIRIK
 */
public class SaviDialogSkeleton extends Dialog implements WindowListener, KeyListener {
    
    /**
     * Creates a new instance of SaviDialogSkeleton, initialize caption.
     * @param caption dialog caption
     */
    public SaviDialogSkeleton(String caption) {
        super(new Frame(), caption, true);
        setResizable(false);
        
        this.addWindowListener(this);
        this.addKeyListener(this);
    }
    
    /**
     * Actions if user press "close".
     */
    protected void closeCalled() {
        this.setVisible(false);
    }
    
    /**
     * Distribute "ESC" key listener to all components included in dialog.
     */
    public void distributeKeyListeners() {
        traverseContainer(this);
    }
    private void traverseContainer(Container c) {
/*        Class isCont = null;
        try {
            isCont = Class.forName("java.awt.Container");
        } catch (Exception e) { 
            return;
        }
  */      for (int i = 0; i < c.getComponentCount(); i++) {
            c.getComponent(i).addKeyListener(this);
            if ((c.getComponent(i)) instanceof Container) {
                traverseContainer((Container)c.getComponent(i));
            }
/*            try {       // <hack>
                traverseContainer((Container)c.getComponent(i));
            } catch (ClassCastException ex) { }      // </hack>   */
        }
    }
    
    // window listener
    /**
     * Capturing "X" close button press.
     * @param evt the window event
     */
    public void windowClosing(WindowEvent evt) {
        closeCalled();
    }
    /**
     * Not used for this class.
     * @param evt the window event
     */
    public void windowClosed(WindowEvent evt) { }
    /**
     * Not used for this class.
     * @param evt the window event
     */
    public void windowDeiconified(WindowEvent evt) { }
    /**
     * Not used for this class.
     * @param evt the window event
     */
    public void windowIconified(WindowEvent evt) { }
    /**
     * Not used for this class.
     * @param evt the window event
     */
    public void windowOpened(WindowEvent evt) { }
    /**
     * Not used for this class.
     * @param evt the window event
     */
    public void windowActivated(WindowEvent evt) {  }
    /**
     * Not used for this class.
     * @param evt the window event
     */
    public void windowDeactivated(WindowEvent evt) { }    
    
    // key listener
    /**
     * Capturing ESC key for closing.
     * @param evt the key event
     */
    public void keyPressed(KeyEvent evt) {
        if (evt.getKeyCode() == KeyEvent.VK_ESCAPE) {
            evt.consume();
            closeCalled();
        }
    }
    /**
     * Not used for this class.
     * @param evt the key event
     */
    public void keyTyped(KeyEvent evt) { }
    /**
     * Not used for this class.
     * @param evt the key event
     */
    public void keyReleased(KeyEvent evt) { }    
}
