/*
 * FunctionMin.java
 *
 * Created on 13. nor 2006, 10:49
 *
 */

package savi.visualization.addons;

import java.lang.*;
import java.awt.*;
import java.text.DecimalFormat;
import savi.alg.StateSkeleton;

import savi.alg.funcmin.*;
import savi.visualization.support.VisualizationInfo;
import savi.visualization.support.SimPanel;

/**
 * Visualization add-on for Finding global minimum problem.
 * @author Premysl JIRIK
 */
public class FunctionMin extends SimPanel {
    Label           lbCost, lbWeight;
    
    /** Creates a new instance of FunctionMin */
    public FunctionMin() {
        super(new ViewFunctionMin(), 50, 1, 0.9, 10);
    }
    
    /**
     * Initialize problem state.
     */
    protected void initState() {
        state = new StateFunction();
    }
    
    /**
     * Initialize components in add-on.
     */
    protected void initComponents() {
        super.initComponents();
        addEmptySpace();
        lbCost = addOutputField("Current cost (Y)", "");
        lbWeight = addOutputField("Current state (X)", "");
        
        settings.doLayout();
    }   

    /**
     * Update info panel (display) with given state.
     * @param s state
     */
    protected void updateDisplay(StateSkeleton s) {
        super.updateDisplay(s);
        
        DecimalFormat df = new DecimalFormat("##0.0000");
        lbCost.setText(df.format(((StateFunction)s).getActualCost()));
        lbWeight.setText(df.format(((StateFunction)s).getCurrentX()));
    }
    
    /**
     * Prepare and return help panel for this problem.
     * @return help panel
     */
    protected VisualizationInfo getInfoPanel() {
        VisualizationInfo vi = new VisualizationInfo();
        vi.addTab("Description", "/res/help/funcmin/funcmin01.gif");
        vi.addTab("Controls", "/res/help/funcmin/funcmin02.gif");
        return vi;
    }
    /**
     * Return name of the problem.
     * @return name of the problem
     */
    public String getSimulationName() {
        return "Finding global minimum";
    }
    
    
}
    
