/*
 * VisualizationInfo.java
 *
 * Created on 4. jen 2006, 22:30
 *
 */

package savi.visualization.support;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.util.ArrayList;
import savi.visualization.SimAnnealingApplet;

/**
 * This class provides help viewer (vizualization).
 * @author Premysl JIRIK
 */
public class VisualizationInfo extends Panel {
    /**
     * panel with components for switching
     */
    protected Panel             switcher;
    /**
     * list of help images
     */
    protected ArrayList         images = new ArrayList();
    /**
     * list of pages names
     */
    protected ArrayList         pageNames = new ArrayList();
    /**
     * index of active page
     */
    protected int               activeTab = 0;
    private Choice            chItems;
    
    /** Creates a new instance of VisualizationInfo */
    public VisualizationInfo() {
        this.setBackground(Color.WHITE);
        this.setLayout(null);
        
        switcher = new Panel();
        switcher.setLayout(null);

        switcher.add(chItems = new Choice());
        chItems.setBounds(2, 2, 416, 21);
        
        switcher.setBounds(0, 0, 420, 25);
        add(switcher);
}
    
    /**
     * Adds new information page.
     * @param caption page caption
     * @param path path to image resource
     */
    public void addTab(String caption, String path) {
        Image img = SimAnnealingApplet.getAppletInstance().getImage(getClass().getResource(path)); 
        if (img == null)
            return;

        pageNames.add(caption);
        images.add(img);
        chItems.add(caption);
        chItems.addItemListener(new ItemListener() {
            public void itemStateChanged(ItemEvent e) {
                update();
            }
        });
    }
    
    /**
     * Paints this component.
     * @param g the graphics context to use for painting
     */
    public void paint(Graphics g) {
        if (images.size() > 0)
            g.drawImage((Image)images.get(activeTab), 0, 25, this);
        else {
            g.setColor(Color.WHITE);
            g.fillRect(0, 25, 420, 420);
        }
        g.setColor(Color.DARK_GRAY);
        g.drawLine(0, 25, 420, 25);
    }
    /**
     * Updates this component.
     * @param g the specified context to use for updating
     */
    public void update(Graphics g) {
        this.paint(g);
    }
    
    /**
     * Update content after page change by user.
     */
    protected void update() {
        activeTab = chItems.getSelectedIndex();
        this.repaint();
    }
}
