/*
 * Visualizable.java
 *
 * Created on 12. nor 2006, 20:37
 *
 */

package savi.visualization.support;

import java.awt.*;
import savi.alg.*;

/**
 * Base class for visualization panels.
 * @author Premysl JIRIK
 */
public abstract class VisualizationPanel extends Panel {
    /**
     * problem state
     */
    protected StateSkeleton state;
    
    /**
     * This method set the state.
     * @param s state
     */
    public void setState(StateSkeleton s) {
        state = s;
        updateScene();
    }
    /**
     * Return reference to state.
     * @return state
     */
    public StateSkeleton getState() {
        return state;
    }
    
    /**
     * This method cause repaint the visualization panel (e.g. after state change).
     */
    abstract public void updateScene();
}
